﻿© 2009 Fluke Corporation, All rights reserved               MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub IEEE-488.2 Identification Query Parse Response
DATE:                  2009-11-30 10:13:42
AUTHOR:                Fluke
REVISION:              $Revision: 1.1 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       94
=============================================================================
#
#  Text Source:
#    $RCSfile: sub_ieee488_2_id_query_parse_resp.txt,v $
#    $Date: 2007/01/04 16:55:47 $
#
#  Procedure Author:   DAC, DFM
#
#  Models covered:     All IEEE-488.2 compatible UUTs
#
#  Compatibility:      MET/CAL 7.20 or later
#
#  Subprocedures:      None
#
#  Required Files:     None
#
#  Required Equipment: None
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

  1.001  MATH         @Manufacturer = FLD(MEM2, 1, ",")
  1.002  MATH         @ModelNum     = FLD(MEM2, 2, ",")
  1.003  MATH         @SerialNum    = FLD(MEM2, 3, ",")
  1.004  MATH         @FirmwareRev  = FLD(MEM2, 4, ",")

# Some manufacturers pad the fields with a space.
#
# Ex. "Hewlett-Packard, E4401B, US39120213, A.06.00"
#
# Strip leading whitespace from fields.

# Check model field for leading whitespace.
  1.005  IF           ZCMP(SUB(@ModelNum, 1, 1), " ")
  1.006  MATH         @ModelNum = SUB(@ModelNum, 2, LEN(@ModelNum))
  1.007  ENDIF

# IEEE-488.2 allows manufacturers to return "0" in the serial number and
# firmware revision fields if the actual serial number and/or firmware
# revision is not available for the *IDN? response string.

# Check serial number field for "0" or leading whitespace.
  1.008  IF           ZCMP(@SerialNum, "0") || ZCMP(@SerialNum, " 0")
  1.009  MATH         @SerialNum = "Not available"
  1.010  ELSEIF       ZCMP(SUB(@SerialNum, 1, 1), " ")
  1.011  MATH         @SerialNum = SUB(@SerialNum, 2, LEN(@SerialNum))
  1.012  ENDIF

# Check firmware revision field for "0" or leading whitespace.
  1.013  IF           ZCMP(@FirmwareRev, "0") || ZCMP(@FirmwareRev, " 0")
  1.014  MATH         @FirmwareRev = "Not available"
  1.015  ELSEIF       ZCMP(SUB(@FirmwareRev, 1, 1), " ")
  1.016  MATH         @FirmwareRev = SUB(@FirmwareRev, 2, LEN(@FirmwareRev))
  1.017  ENDIF

# Make sure firmware level string is not too big for DISP statement line.
  1.018  MATH         Max = 56 - LEN("Firmware Level:") - 2
  1.019  MATH         LenFirmwareRev = LEN(@FirmwareRev)

  1.020  IF           LenFirmwareRev > Max
  1.021  MATH         Part1 = SUB(@FirmwareRev, 1, Max)
  1.022  MATH         Part2 = SUB(@FirmwareRev, (Max + 1), LenFirmwareRev)
  1.023  DISP         Manufacturer:    [V @Manufacturer]
  1.023  DISP         Model:           [V @ModelNum]
  1.023  DISP         Serial Number:   [V @SerialNum]
  1.023  DISP         Firmware Level:  [V Part1]
  1.023  DISP         [32]                [V Part2]
# Write serial number and firmware revision to results file.
  1.024  RSLT         =
  1.025  RSLT         = Serial Number:   [V @SerialNum]
  1.026  RSLT         = Firmware Level:  [V Part1]
  1.027  RSLT         =[32]                 [V Part2]
  1.028  ELSE
  1.029  DISP         Manufacturer:    [V @Manufacturer]
  1.029  DISP         Model:           [V @ModelNum]
  1.029  DISP         Serial Number:   [V @SerialNum]
  1.029  DISP         Firmware Level:  [V @FirmwareRev]
# Write serial number and firmware revision to results file.
  1.030  RSLT         =
  1.031  RSLT         = Serial Number:   [V @SerialNum]
  1.032  RSLT         = Firmware Level:  [V @FirmwareRev]
  1.033  ENDIF

  1.034  END
